program serial_comm;

USES DOS,Crt,mouse; {Ownmouse,}

procedure retrace; forward;
procedure veranderxveld(x,y,player:word);forward;
procedure veranderyveld(x,y,player:word);forward;
procedure put_grid; forward;

{$define joost_computer}

CONST
  COM2      = $2F8;    { Communications port 2 address.     }
  THR       = $00;     { Transmitter holding register.      }
  RDR       = $00;     { Receiver data register.            }
  BRDL      = $00;     { Baud rate low divisor register.    }
  BRDH      = $01;     { Baud rate high divisor register.   }
  IER       = $01;     { Interrupt enable register.         }
  IIR       = $02;     { Interrupt identIFication register. }
  LCR       = $03;     { Line control register.             }
  MCR       = $04;     { Modem control register.            }
  LSR       = $05;     { Line status register.              }
  MSR       = $06;     { Modem status register.             }

  SET_BAUD  = $80;     { DLAB.                              }
  CTS_DSR   = $30;     { Check for DSR and CTS in MSR.      }
  THREMPTY  = $20;     { Check for THR empty in LSR.        }

  WORD7      = $02;    { Bits 0 and 1 when setting LCR.     }
  WORD8      = $03;
  BIT1       = $00;    { Bit 3 when setting LCR.            }
  BIT2       = $04;
  NONE       = $00;    { Bits 4, 5, and 6 when setting LCR. }
  EVEN       = $30;
  ODD        = $20;

  INT_ENABL  = $0B;    { Tell UART to perform interrupts.   }
  PIC        = $20;    { Address of PIC.                    }
  PIC_CNTL   = $21;    { Address of PIC control register.   }
  EOI        = $20;    { End of interrupt signal for PIC.   }
  DATA_REC   = $01;    { Interrupt on data received.        }
  WRITE_CH   = $0E;    { Write character function.          }

  XON_CH     = #$11;   { XON protocol control character.    }
  XOFF_CH    = #$13;   { XOFF protocol control character.   }
  EOT        = #$04;   { End of transmission character.     }

  MAX_BUFF   = 256;     { Maximum characters in the buffer.  }
  BUFF_FULL  = 0.75;    { Buffer full @ 75% of MAX_BUFF.     }
  BUFF_EMPT  = 0.50;    { Buffer empty @ 50% of MAX_BUFF.    }

  ERR        = -1;

  Com_baud   : string[10] ='9600';
  Com_parity : Char='N';
  Com_databits:char='8';
  Com_stopbits:char='1';
  {$ifdef joost_computer}
  Com_Nr:char='1';
  {$else}
  Com_Nr:char='2';
  {$endif}

VAR
  buff_Count : INTEGER;      { Number of characters in buffer.    }
  xon        : BOOLEAN;      { Enable send ability.               }
  COM1:word;{ $3F8;    { Communications port 1 address.     }
  COM_INT:byte;{    = $0C;    { Communications interrupt to tap.   }
  IRQ4_MASK:byte;{ $EF;    { Mask for IRQ4.                     }
  {MARK}
  cursorx,cursory:word;
  self_cursorx,self_cursory:word;
  cursorcolor:byte;
  cursorshadow:byte;
  incomingpacket_Seg:word;
  incomingpacket_Ofs:word;
  incomingpacket_Pos:word;
  incomingpacket_Size:word;
  incomingpacket_type:byte;
  incomingBuffer:array[0..255] of byte;
  incomingBufferpos:word;
  incomingBufferposlastread:word;
  mousepacket:array[0..8] of byte;
  stringpacket:array[0..255] of byte;
  stringpacketout:string;
  cntr:word;

var  fnaam1,fnaam2,fnaam3,fnaam4,fnaam5,fnaam6,fnaam7,fnaam8: file; {1=font 2=pict 3=pal}
     fnaam9,fnaam10,fnaam11,fnaam12,fnaam13,fnaam14:file;

     pijlrd,pijlbl,rd_l,rd_lv,bl_l,bl_lv,zw_l,zw_lv,wt_l,wt_lv,kamerv,pal,scrn,scrn2: pointer;
     pijlrds,pijlbls,rd_ls,rd_lvs,bl_ls,bl_lvs,zw_ls,zw_lvs,wt_ls,wt_lvs,kamervs,pals,scrns,scrn2s: word;
     pijlrd_b,pijlbl_b:pointer;
     pijlrd_bs,pijlbl_bs:word;

     knop,dx,dy,pix,allx,ally,calcx,calcy,beurt: word;
     clipx,clipy,clipx2,clipy2: integer;
     mx,my,mx2,my2:integer;
     mx_inbox,my_inbox,mx2_inbox,my2_inbox:integer;

     veldx:array[0..16,0..9] of byte;
     veldy:array[0..16,0..9] of byte;
     veldgewonnen:array[0..16,0..9] of byte;
     vaant: array[0..2] of word;

     keypress:char;
     otherplayer_message:string;
     otherplayer_message_secpoint:word;
     implayernr:byte;
     self_score:word;
     other_score:word;
     self_win:word;
     other_win:word;
     self_id:word;
     other_id:word;
     click_veld_x,click_veld_y:word;
     aantal_hokjes_dicht:word;
     aantal_hokjes_dicht_prev:word;

function GetTimeSeconds:word;
var
  dummy:word;
  uit:word;
begin
  GetTime(dummy,dummy,uit,dummy);
  GetTimeSeconds:=uit;
end;


procedure backspace(VAR instr:string);
var
  uit:String;
  cntr:word;
begin
  if length(instr)>0 then begin
    uit:='';
    for cntr:=1 to length(instr)-1 do begin
      uit:=uit+instr[cntr];
    end;
    instr:=uit;
  end;
end;

PROCEDURE PutPixel( X,Y :WORD; Color :BYTE );
BEGIN
  if (x<320) AND (y<200) then Mem[scrn2s:(320*Y)+X]:= Color;
END;

PROCEDURE WriteXY( X,Y :WORD; Color :BYTE; Ch :char );
VAR
   OldX :WORD;                  { Holds Original Column.                }
   OldY :WORD;
   StrPos :BYTE;                { Character pos in string to write.     }
   FontChr:BYTE;                { ROM font info.                        }
   FontPos:BYTE;
   BitPos :BYTE;
BEGIN
  OldY := Y;                    { Save Starting Row.                    }

   OldX := X;                   { Save Current Column.                  }
   Y := OldY;                   { Restore starting row.                 }
   FOR FontPos := 0 TO 7 DO
   BEGIN                        { Scroll through all 8 BYTES of font.   }
    FontChr := MEM[$FFA6:$E+(ORD(Ch) SHL 3) + FontPos];
    FOR BitPos := 7 DOWNTO 0 DO
    BEGIN                       { Scroll through all 8 BITS of each BYTE.}
     IF (FontChr AND (1 SHL BitPos)) <> 0 THEN begin
      PutPixel(X,Y,Color);      { IF bit is set then draw pixel.        }
      PutPixel(X+1,Y,cursorshadow);
      PutPixel(X+1,Y+1,cursorshadow);
      PutPixel(X,Y+1,cursorshadow);
      end;
     INC(X);                    { point to next column.                 }
    END;
    INC(Y);                     { point to next row.                    }
    X := OldX;                  { Restore old column for next line.     }
   END;
   X := X + 8;                  { Move 9 columns ahead.                 }
END;{WriteXY}

procedure writech(ch:char);
begin
  writeXY(cursorx*8,cursory*8,cursorcolor,ch);
  inc(cursorx);
  if (cursorx>=40) then begin
    cursorx:=cursorx-40;
    inc(cursory);
  end;
  if (cursory>=25) then begin
    cursory:=0;
  end;
end;
procedure writestr(s:String);
var
  cntr_loc:word;
begin
  for cntr_loc:=1 to length(s) do begin
    writeXY(cursorx*8,cursory*8,cursorcolor,s[cntr_loc]);
    inc(cursorx);
    if (cursorx>=40) then begin
      cursorx:=cursorx-40;
      inc(cursory);
    end;
    if (cursory>=25) then begin
      cursory:=0;
    end;
  end;
end;

procedure ch_res(vmode:byte); assembler;
 asm
  mov ah,0
  mov al,vmode;
  int 10h;
end;

procedure retrace; assembler;
{ Waits until vertical retrace }
asm
        MOV  DX,3DAh
@@1:    IN   AL,DX
        TEST AL,8
        JZ   @@1
@@2:    IN   AL,DX
        TEST AL,8
        JNZ  @@2
end;

procedure strangedelay;
var
  cntr:word;
  cntr2:word;
  cntr3:word;
begin
  for cntr:=0 to 1000 do begin
    for cntr2:=0 to 10000 do begin
      cntr3:=cntr2;
    end;
  end;
end;

procedure setpal (col, r, g, b : byte); assembler;
{sets rgb-palette}
asm
  mov dx,03c8h
  mov al,col
  out dx,al
  inc dx
  mov al,r
  out dx,al
  mov al,g
  out dx,al
  mov al,b
  out dx,al
end;

PROCEDURE setup( baud, parity, data_bits, stop_bits : INTEGER );
VAR
  setup : INTEGER;

Begin
  setup := parity;


  { Set DLAB such that baud rate can be changed/set. }
  Port[ COM1 + LCR ] := SET_BAUD;

  CASE baud OF
     300 : Begin
             Port[ COM1 + BRDL ] := $80;
             Port[ COM1 + BRDH ] := $01;
           End;
    1200 : Begin
             Port[ COM1 + BRDL ] := $60;
             Port[ COM1 + BRDH ] := $00;
           End;
    2400 : Begin
             Port[ COM1 + BRDL ] := $30;
             Port[ COM1 + BRDH ] := $00;
           End;
    9600 : Begin
             Port[ COM1 + BRDL ] := $0C;
             Port[ COM1 + BRDH ] := $00;
           End;
  End;

  CASE data_bits OF
    7  : setup := setup OR WORD7;
    8  : setup := setup OR WORD8;
  End;

  CASE stop_bits OF
    1  : setup := setup OR BIT1;
    2  : setup := setup OR BIT2;
  End;

  { Send final (calculated) setup Value to the communications port. }
  Port[ COM1 + LCR ] := setup;
End;

PROCEDURE add_char( ch : CHAR );
Begin
  incomingBuffer[incomingBufferpos]:=ORD(Ch);
  inc(incomingBufferpos);
  incomingBufferpos:=incomingBufferpos mod MAX_BUFF;
End;

{$F+}
PROCEDURE receive_ch; INTERRUPT;
VAR
  ch : CHAR;

Begin
  ch := CHAR(Port[ COM1 + RDR ]);

  IF( ch = XON_CH ) THEN
    xon := TRUE
  ELSE IF( ch = XOFF_CH ) THEN
    xon := FALSE
  ELSE
    add_char( CHAR(ch) );
 
  { Send End of interrupt signal to PIC chip. }
  Port[ PIC ] := EOI;
End;
{$F-}

PROCEDURE xmit( ch : CHAR );
Begin
  Port[ COM1 + THR ] := INTEGER(ch);
  delay(20);
End;

FUNCTION can_xmit : BOOLEAN;
Begin
  {  IF input characters can be sent, and the DSR, CTS and THREMPTY are
     all set high, then the character read from keyboard can be sent.
  }
  IF( xon AND ((Port[ COM1 + MSR ] AND CTS_DSR)  = CTS_DSR) AND
             ((Port[ COM1 + LSR ] AND THREMPTY) = THREMPTY) ) THEN
    can_xmit := TRUE
  ELSE
    can_xmit := FALSE;

End;

procedure send_mouse_packet(mX_,mY_:word);
begin
  xmit( CHR(20) ); {packet-type}
  xmit( CHR(32+(mX_ shr 6)) );
  xmit( CHR(32+(mX_ and 63)) );
  xmit( CHR(32+(mY_ shr 6)) );
  xmit( CHR(32+(mY_ and 63)) );
  xmit( CHR(13) );
end;
procedure send_veldx_change(xpos,ypos,implayernr:word);
begin
  xmit( CHR(5) );
  xmit( CHR(32+xpos) );
  xmit( CHR(32+ypos) );
  xmit( CHR(32+implayernr) );
  xmit( CHR(13) );
end;
procedure send_veldy_change(xpos,ypos,implayernr:word);
begin
  xmit( CHR(6) );
  xmit( CHR(32+xpos) );
  xmit( CHR(32+ypos) );
  xmit( CHR(32+implayernr) );
  xmit( CHR(13) );
end;

procedure send_string_packet(str:String);
var
  cntr_loc:word;
begin
  xmit( CHR(21) ); {packet-type}
  for cntr_loc:=1 to length(str) do begin
    xmit( str[cntr_loc] );
  end;
  xmit( CHR(13) );
end;
procedure send_id_packet; {send id}
var
  cntr:word;
begin
  xmit( CHR(29) );
  for cntr:=0 to 1 do begin
    xmit(CHR(mem[SEG(self_id):OFS(self_id)+cntr]));
  end;
  xmit( CHR(13) );
end;
procedure send_id_request; {send id request}
begin
  xmit( CHR(28) );
end;
procedure send_jijhebtdebeurt;
begin
  xmit( CHR(25) );
end;

procedure send_newgame_packet;
begin
  xmit( CHR(27) );
end;


function showstringpacket:string;
var
  ch:char;
  cntr_loc:word;
  uit:string;
begin
  cntr_loc:=0;
  uit:='';
  repeat
    ch:=CHR(stringpacket[cntr_loc]);
    if (ch<>CHR(13)) then uit:=uit+ch;
    inc(cntr_loc);
  until (ch=CHR(13)) or (cntr_loc=255);
  showstringpacket:=uit;
end;

function incomingBuffer_getbyte:integer;
begin
    IF (incomingBufferpos<>incomingBufferposlastread) THEN begin
      incomingBuffer_getbyte:=incomingBuffer[incomingBufferposlastread];
      inc(incomingBufferposlastread);
      incomingBufferposlastread:=incomingBufferposlastread MOD MAX_BUFF;
    end else begin
      incomingBuffer_getbyte:=-1;
    end;
end;

procedure copy_boterks2scrns;
begin
  ally:=0;
  for allx:=0 to 15999 do begin
    meml[scrns:ally]:=meml[kamervs:ally];
    inc(ally,4);
  end;
end;

procedure ResetGame;
VAR
  cntr,cntr2:word;
begin
  if self_score>=other_score then inc(self_win);
  if self_score<=other_score then inc(other_win);
  self_score:=0;
  other_score:=0;
  for cntr2:=0 to 8 do begin {clear Veld}

    for cntr:=0 to 15 do begin
      veldx[cntr,cntr2]:=0;
      veldy[cntr,cntr2]:=0;
    end;
  end;
  for cntr2:=0 to 7 do begin {clear Veld}
    for cntr:=0 to 14 do begin
      veldgewonnen[cntr,cntr2]:=0;
    end;
  end;
{ implayernr:=3-implayernr; {switch players}
  copy_boterks2scrns;
  put_grid;
end;






PROCEDURE Serial;
VAR
  ch       : CHAR;       { Character read from the keyboard.    }
  word_loc:word;
  ch_loc:integer;
  cntr_loc:word;
Begin
    if (other_id=0) then begin
      send_id_request;
    end;

    send_mouse_packet(mX,mY);

    ch_loc:=incomingBuffer_getbyte;
    IF (ch_loc<>-1) THEN Begin
      { Display a character from the buffer. }

      repeat
        {Stuur pakket-data naar geheugen-plaats}
        if (incomingpacket_Pos<incomingpacket_Size) then begin
          mem[incomingpacket_SEG:incomingpacket_OFS+incomingpacket_Pos]:=ORD(ch_loc);
          inc(incomingpacket_Pos);
        end;
        {pakket compleet verzonden}
        if (incomingpacket_Pos=incomingpacket_Size) then begin
          incomingpacket_type:=0;
          incomingpacket_Size:=0;
          incomingpacket_Pos:=0;
        end;

        {einde-packet!}
        if ch_loc=13 then begin
          if incomingpacket_type=20 then begin {muis pakketje binnengekomen}
            cursorx:=0;
            cursory:=0;
            for cntr_loc:=0 to 3 do begin
              dec(stringpacket[cntr_loc],32);
            end;
            mx2:=integer(stringpacket[0]) shl 6+integer(stringpacket[1]);
            my2:=integer(stringpacket[2]) shl 6+integer(stringpacket[3]);
          end;
          if incomingpacket_type=21 then begin {msg pakketje binnengekomen}
            otherplayer_message:=showstringpacket;
            otherplayer_message_secpoint:=GetTimeSeconds;
          end;
          if incomingpacket_type=29 then begin {other id binnen}
            for cntr_loc:=0 to 1 do begin
              mem[SEG(other_id):OFS(other_id)+cntr_loc]:=stringpacket[cntr_loc];
            end;
            if other_id>self_id then begin
              beurt:=2;
              implayernr:=2;
            end;
          end;
          if incomingpacket_type=5 then begin {veldclickx binnen}
            for cntr_loc:=0 to 2 do begin
              dec(stringpacket[cntr_loc],32);
            end;
            veranderxveld(stringpacket[0],stringpacket[1],stringpacket[2]);
          end;
          if incomingpacket_type=6 then begin {veldclicky binnen}
            for cntr_loc:=0 to 2 do begin
              dec(stringpacket[cntr_loc],32);
            end;
            veranderyveld(stringpacket[0],stringpacket[1],stringpacket[2]);
          end;
          incomingpacket_Size:=0;  {reset}
          incomingpacket_Pos:=0;
          incomingpacket_type:=0;
        end;


        if ch_loc=25 then begin {ik krijg de beurt!}
          beurt:=1;
        end;
        if ch_loc=27 then begin {resetGame}
          resetGame;
          inc(other_score);
        end;
        {request id}
        if ch_loc=28 then begin
          send_id_packet;
        end;
        {13-terminated clickedonveld packet comes in}
        if (ch_loc=5) OR (ch_loc=6) then begin
          incomingpacket_Seg:=SEG(stringpacket);
          incomingpacket_Ofs:=OFS(stringpacket);
          incomingpacket_Size:=255;
          incomingpacket_Pos:=0;
          incomingpacket_type:=ch_loc;
        end;
        {13-terminated request id reply comes in}
        if ch_loc=29 then begin
          incomingpacket_Seg:=SEG(stringpacket);
          incomingpacket_Ofs:=OFS(stringpacket);
          incomingpacket_Size:=255;
          incomingpacket_Pos:=0;
          incomingpacket_type:=ch_loc;
        end;
        {13-terminated mouse packet comes in}
        if ch_loc=20 then begin
          incomingpacket_Seg:=SEG(stringpacket);
          incomingpacket_Ofs:=OFS(stringpacket);
          incomingpacket_Size:=255;
          incomingpacket_Pos:=0;
          incomingpacket_type:=ch_loc;
        end;
        {13-terminated string packet comes in}
        if ch_loc=21 then begin
          incomingpacket_Seg:=SEG(stringpacket);
          incomingpacket_Ofs:=OFS(stringpacket);
          incomingpacket_Size:=255;
          incomingpacket_Pos:=0;
          incomingpacket_type:=ch_loc;
        end;

        ch_loc:=incomingBuffer_getbyte;
      until (ch_loc=-1);

    End;
End;

FUNCTION Value( NumS : STRING ) : LONGINT;
VAR
  O, M, S, C : LONGINT;

Begin
  S := 0;
  M := 1;
  FOR C := Length(NumS) DOWNTO 1 DO
  Begin
    O := Ord( NumS[C] );
    IF NumS[C] IN ['0'..'9'] THEN
    Begin
      INC( S, M * (O - 48) );
      M := M * 10;
    End;
  End;
  Value := S;
End;

FUNCTION UCase( S : STRING ) : STRING;
VAR
  C : BYTE;

Begin
  FOR C := 1 TO Length(S) DO
    S[C] := UpCase( S[C] );

  UCase := S;
End;





VAR
  Count,                { Simple Counter.                    }
  baud,                 { Baud rate.                         }
  parity,               { Parity    - NONE, EVEN, ODD.       }
  data_bits,            { Data bits - 7, 8.                  }
  stop_bits  : INTEGER; { Stop bits - 1, 2.                  }
  temp,
  SecParam   : STRING;
  save_int   : POINTER;


procedure serialinit;
begin
  incomingpacket_Size:=0;
  incomingpacket_Pos:=0;
  incomingpacket_type:=0;
  incomingBufferpos:=0;
  incomingBufferposlastread:=0;
  stringpacketout:='';
  cursorx:=0;
  cursory:=0;
  self_cursorx:=0;
  self_cursory:=24;
  cursorcolor:=255;
  cursorshadow:=0;
  writestr('(Start)');

  buff_Count := 0;
  xon        := TRUE;

  CASE Com_Nr OF
    '1' : begin
            COM1:=$3F8;
            COM_INT:=$0C; {hardware interrupt 4 = software interrupt 4+8=12}
            IRQ4_MASK:=$EF; { $FF-16}
          end;
    '2' : begin
            COM1:=$2F8;
            COM_INT:=$0B; {hardware interrupt 3 = software interrupt 3+8=11}
            IRQ4_MASK:=$FF-8;
          end;
  end;
{ writestr('(Com adres:'+Com1+')');
  writestr('(Com int:',Com_Int,')');
  writestr('(IRQ mask:',Irq4_mask,')');}

  baud := Value( Com_baud );

  { Convert second argument to upper case so first letter can be checked
    for parity. }
  SecParam := Com_parity;
  SecParam := UCase( SecParam );

  { Check first character of 2nd command line parameter for parity. }
  CASE SecParam[1] OF
    'N' : parity := NONE;
    'O' : parity := ODD;
    'E' : parity := EVEN;
  End;

  data_bits := Value( Com_databits );
  stop_bits := Value( Com_stopbits );
  getintvec( COM_INT, save_int );
  SetIntVec( COM_INT, Addr( receive_ch ) ); { Set vector = $0C to new interrupt routine. }
  setup( baud, parity, data_bits, stop_bits );{ Initialize the modem }
  Port[ COM1 + IER ] := DATA_REC; { Interrupt on received character. }
  Port[ COM1 + MCR ] := INT_ENABL; { Enable interrupts }
  Port[ PIC_CNTL ] := Port[ PIC_CNTL ] AND IRQ4_MASK; { Set PIC control register to enable IRQ4. }
  Port[ COM1 + MSR ] := CTS_DSR; { Set MSR such that CTS and DSR are high. }
end;


procedure vsync; assembler;
 asm
  mov dx,3dah;
  @vert1: in al,dx;
  test al,8;
  jz @vert1
  @vert2: in al,dx;
  test al,8;
  jnz @vert2;
end;

procedure setcols(cnum,rw,gw,bw:byte); assembler;
 asm
  mov dx,3c8h;

  mov al,[cnum];  {zet colnum in al}
  out dx,al;   {zet al in dx}
  inc dx;      {nxt byte voor de rgb waarden}

  mov al,[rw]
  out dx,al;

  mov al,[gw];
  out dx,al;

  mov al,[bw];
  out dx,al;
end;


procedure read_pic;
begin
  {$ifdef joost_computer}
    chdir('d:\coding\kamerv\');
  {$endif}
  assign(fnaam1,'pijlrd.raw'); {,uis pijl 1}
  assign(fnaam2,'rd_l.raw');
  assign(fnaam3,'rd_lv.raw'); {lijn vertikaal rood}
  assign(fnaam4,'kamerv.raw'); {main frame}
  assign(fnaam5,'kamerv.act');
  assign(fnaam6,'pijlbl.raw'); {muis pijl 2}
  assign(fnaam7,'bl_l.raw');
  assign(fnaam8,'bl_lv.raw'); {lijn vertikaal blauw}
  assign(fnaam9,'zw_l.raw');
  assign(fnaam10,'zw_lv.raw'); {lijn vertikaal zwat}
  assign(fnaam11,'wt_l.raw');
  assign(fnaam12,'wt_lv.raw'); {lijn vertikaal wit}
  assign(fnaam13,'pijlrd_b.raw'); {,uis pijl 1}
  assign(fnaam14,'pijlbl_b.raw'); {,uis pijl 1}

  reset(fnaam1,1);
  reset(fnaam2,1);
  reset(fnaam3,1);
  reset(fnaam4,1);
  reset(fnaam5,1);
  reset(fnaam6,1);
  reset(fnaam7,1);
  reset(fnaam8,1);
  reset(fnaam9,1);
  reset(fnaam10,1);
  reset(fnaam11,1);
  reset(fnaam12,1);
  reset(fnaam13,1);
  reset(fnaam14,1);

  getmem(pijlrd,3744);
  getmem(pijlbl,3744);
  getmem(pijlrd_b,3744);
  getmem(pijlbl_b,3744);

  getmem(rd_l,42);
  getmem(rd_lv,42);
  getmem(bl_l,42);
  getmem(bl_lv,42);
  getmem(zw_l,42);
  getmem(zw_lv,42);
  getmem(wt_l,42);
  getmem(wt_lv,42);

  getmem(kamerv,64000);
  getmem(pal,768);

  getmem(scrn2,64000); {alles + muis}
  scrn2s:=seg(scrn2^);
  getmem(scrn,64000); {alles zonder muis}
  scrns:=seg(scrn^);

  pijlrds:=seg(pijlrd^);  {seg= beginplek van een geheugen blok  offset=plaats van dat blok geheugen}
  pijlbls:=seg(pijlbl^);
  pijlrd_bs:=seg(pijlrd_b^);
  pijlbl_bs:=seg(pijlbl_b^);

  rd_ls:=seg(rd_l^);
  rd_lvs:=seg(rd_lv^);
  bl_ls:=seg(bl_l^);
  bl_lvs:=seg(bl_lv^);
  zw_ls:=seg(zw_l^);
  zw_lvs:=seg(zw_lv^);
  wt_ls:=seg(wt_l^);
  wt_lvs:=seg(wt_lv^);

  kamervs:=seg(kamerv^);
  pals:=seg(pal^);

  blockread(fnaam1,pijlrd^,3744);  {72*72}

  blockread(fnaam2,rd_l^,42);
  blockread(fnaam3,rd_lv^,42);

  blockread(fnaam4,kamerv^,64000);
  blockread(fnaam5,pal^,768);

  blockread(fnaam6,pijlbl^,3744);  {72*72}

  blockread(fnaam7,bl_l^,42);
  blockread(fnaam8,bl_lv^,42);
  blockread(fnaam9,zw_l^,42);
  blockread(fnaam10,zw_lv^,42);
  blockread(fnaam11,wt_l^,42);
  blockread(fnaam12,wt_lv^,42);
  blockread(fnaam13,pijlrd_b^,3744);
  blockread(fnaam14,pijlbl_b^,3744);

  close(fnaam1);
  close(fnaam2);
  close(fnaam3);
  close(fnaam4);
  close(fnaam5);
  close(fnaam6);
  close(fnaam7);
  close(fnaam8);
  close(fnaam9);
  close(fnaam10);
  close(fnaam11);
  close(fnaam12);
  close(fnaam13);
  close(fnaam14);
end;

procedure get_muis;   {andere muis cors krijgen}
begin
  readmouse;
  mx:=mouse_info.wherex;
  my:=mouse_info.wherey;
  knop:=0;
  if mouse_info.left_pressed then knop:=1;
  if mouse_info.right_pressed then knop:=2;

end;


procedure put_back;
begin
  ally:=0;
  for allx:=0 to 15999 do begin
    meml[scrn2s:ally]:=meml[scrns:ally];
    inc(ally,4);
  end;
end;

procedure put_red_mouse(X,Y:integer);
var
  clipx,clipy:integer;
  segfrom:word;
begin
  if (beurt=1) XOR (implayernr=2) then begin
    segfrom:=pijlrd_bs;
  end else begin
    segfrom:=pijlrds;
  end;

  clipx:=71;
  if x>319-71 then clipx:=71-(x-(319-71));
  clipy:=51;
  if y>199-51 then clipy:=51-(y-(199-51));

  if (clipx>=0) AND (clipy>=0) then begin
    for ally:=0 to clipy do begin    {put muissie}
      for allx:=0 to clipx do begin
       pix:=mem[segfrom:allx+ally*72];
       if pix<>115 then mem[scrn2s:(allx+x)+(y+ally)*320]:=pix;
      end;
    end;
  end;
end;
procedure put_blue_mouse(X,Y:integer);
var
  clipx,clipy:integer;
  segfrom:word;
begin
  if (beurt=2) XOR (implayernr=2) then begin
    segfrom:=pijlbl_bs;
  end else begin
    segfrom:=pijlbls;
  end;

  clipx:=71;
  if x>319-71 then clipx:=71-(x-(319-71));
  clipy:=51;
  if y>199-51 then clipy:=51-(y-(199-51));

  if (clipx>=0) AND (clipy>=0) then begin
    for ally:=0 to clipy do begin    {put muissie}
      for allx:=0 to clipx do begin
       pix:=mem[segfrom:allx+ally*72];
       if pix<>115 then mem[scrn2s:(allx+x)+(y+ally)*320]:=pix;
      end;
    end;
  end;
end;

procedure put_curs(mx,my:word);
begin

  if (implayernr=1) then begin
    if (beurt=1) then begin
      put_blue_mouse(mx2,my2);
      put_red_mouse(mx,my);    {my mouse on top}
    end;
    if (beurt=2) then begin
      put_red_mouse(mx,my);
      put_blue_mouse(mx2,my2);
    end;
  end;
  if (implayernr=2) then begin
    if (beurt=1) then begin
      put_red_mouse(mx2,my2);
      put_blue_mouse(mx,my);    {my mouse on top}
    end;
    if (beurt=2) then begin
      put_blue_mouse(mx,my);
      put_red_mouse(mx2,my2);
    end;
  end;

end;


procedure make_pal;
begin
  for allx:=0 to 255 do begin
    setcols(allx,mem[pals:ally] shr 2,mem[pals:ally+1] shr 2,mem[pals:ally+2] shr 2);
    inc(ally,3);
  end;
end;

function IntToStr(I: Longint): String;
{ Convert any integer type to a string }
var
  S: string[11];
begin
  Str(I, S);
  IntToStr := S;
 end;

procedure put_muisenscrn;
begin
  get_muis;
  put_back;

    cursorx:=0;
    cursory:=24;
    if (implayernr=1) then cursorcolor:=18;
    if (implayernr=2) then cursorcolor:=13*16+2;
    cursorshadow:=255;
    writestr(stringpacketout);
    cursorx:=0;
    cursory:=0;
    if (implayernr=1) then cursorcolor:=13*16+2;
    if (implayernr=2) then cursorcolor:=18;
    cursorshadow:=255;
    writestr(otherplayer_message);
    {expired otherplayer_message}
    if ((GetTimeSeconds-otherplayer_message_secpoint+60) MOD 60)>=8 then begin
      otherplayer_message:='';
    end;

    cursorshadow:=255;

    {SCORE DEPARTMENT}
    cursory:=22;

    cursorx:=4;
    cursorcolor:=18;
    if (implayernr=1) then writestr(inttostr(self_score));
    if (implayernr=2) then writestr(inttostr(other_score));

    cursorx:=17;
    cursorcolor:=16*13+3;
    writestr('SCORE');

    cursorx:=34;
    cursorcolor:=13*16+2;
    if (implayernr=1) then writestr(inttostr(other_score));
    if (implayernr=2) then writestr(inttostr(self_score));

    {WINS DEPARTMENT}
    cursory:=24;

    cursorx:=4;
    cursorcolor:=18;
    if (implayernr=1) then writestr(inttostr(self_win));
    if (implayernr=2) then writestr(inttostr(other_win));

    cursorx:=17;
    cursorcolor:=16*13+3;
    writestr('WINS');

    cursorx:=34;
    cursorcolor:=13*16+2;
    if (implayernr=1) then writestr(inttostr(other_win));
    if (implayernr=2) then writestr(inttostr(self_win));



(*  cursorx:=0;
    cursory:=1;
    cursorcolor:=255;
    if implayernr=1 then writestr('playernr 1');
    if implayernr=2 then writestr('playernr 2');
    cursorx:=0;
    cursory:=2;
    cursorcolor:=255;
    if beurt=1 then writestr('beurt 1');
    if beurt=2 then writestr('beurt 2');

    cursorx:=0;
    cursory:=3;
    cursorcolor:=255;
    writestr('my id:'+inttostr(self_id));

    cursorx:=0;
    cursory:=4;
    cursorcolor:=255;
    writestr('other id:'+inttostr(other_id));*)

  put_curs(mx,my);


  dy:=0;
  for dx:=0 to 15999 do begin
    meml[$a000:dy]:=meml[scrn2s:dy];
    inc(dy,4);
  end;
end;

procedure putblk(blkx,blky,bsoort,angle:word);
begin
inc(blkx,1);
inc(blky,1);

if angle=0 then begin

  if bsoort=0 then begin
   for allx:=0 to 20 do begin
    mem[scrns:allx+blkx+blky*320]:=mem[zw_ls:allx];
    mem[scrns:allx+blkx+blky*320+320]:=mem[zw_ls:allx+21];
   end;

  end else if bsoort=1 then begin
   for allx:=0 to 20 do begin
     mem[scrns:allx+blkx+blky*320]:=mem[rd_ls:allx];
     mem[scrns:allx+blkx+blky*320+320]:=mem[rd_ls:allx+21];
    end;

  end else if bsoort=2 then begin
   for allx:=0 to 20 do begin
    mem[scrns:allx+blkx+blky*320]:=mem[bl_ls:allx];
    mem[scrns:allx+blkx+blky*320+320]:=mem[bl_ls:allx+21];
   end;

  end else if bsoort=3 then begin
   for allx:=0 to 20 do begin
    mem[scrns:allx+blkx+blky*320]:=mem[wt_ls:allx];
    mem[scrns:allx+blkx+blky*320+320]:=mem[wt_ls:allx+21];
   end;


 end;

 end else if angle=1 then begin

  if bsoort=0 then begin

   for ally:=0 to 20 do begin
    mem[scrns:blkx+(blky+ally)*320]:=mem[zw_lvs:ally*2];
    mem[scrns:blkx+1+(blky+ally)*320]:=mem[zw_lvs:ally*2+1];
   end;

  end else if bsoort=1 then begin
   for ally:=0 to 20 do begin
    mem[scrns:blkx+(blky+ally)*320]:=mem[rd_lvs:ally*2];
    mem[scrns:blkx+1+(blky+ally)*320]:=mem[rd_lvs:ally*2+1];
   end;

  end else if bsoort=2 then begin
   for ally:=0 to 20 do begin
    mem[scrns:blkx+(blky+ally)*320]:=mem[bl_lvs:ally*2];
    mem[scrns:blkx+1+(blky+ally)*320]:=mem[bl_lvs:ally*2+1];
   end;

  end else if bsoort=3 then begin
   for ally:=0 to 20 do begin
    mem[scrns:blkx+(blky+ally)*320]:=mem[wt_lvs:ally*2];
    mem[scrns:blkx+1+(blky+ally)*320]:=mem[wt_lvs:ally*2+1];
   end;

  end;

 end;

end;

procedure chk_dicht(player:word); {player= degene die aan de beurt is}
var chkx,chky,vakcnt: word;
    ah_loc:word;
begin
  aantal_hokjes_dicht:=0;
  for chky:=0 to 9 do begin
    for chkx:=0 to 15 do begin

     if (veldgewonnen[chkx,chky]=0) then begin
       if (veldx[chkx,chky]>0) and (veldy[chkx,chky]>0) and (veldx[chkx,chky+1]>0)
          and (veldy[chkx+1,chky]>0) then begin
         inc(aantal_hokjes_dicht); {een kamer erbij!}
         if (implayernr=player) then begin
           inc(self_score);
         end else begin
           inc(other_score);
         end;
         veldgewonnen[chkx,chky]:=1;
         putblk(chkx*21,chky*21,player,0);
         putblk(chkx*21,chky*21,player,1);
         putblk((chkx+1)*21,chky*21,player,1);
         putblk(chkx*21,(chky+1)*21,player,0);
       end;
     end;
    end;
  end;

  ah_loc:=0;
  for chky:=0 to 7 do begin
    for chkx:=0 to 14 do begin
      if (veldgewonnen[chkx,chky]=0) then ah_loc:=1;
    end;
  end;
  if (ah_loc=0) then begin {als alle hokjes dicht zijn:}
    ResetGame;
    send_newgame_packet;
  end;
end;


procedure veranderxveld(x,y,player:word); {de andere computer geeft dit..}
var
  cntr:word;
  cntr2:word;
  getem:integer;
begin
  veldx[x,y]:=1;         {staafje wordt bezet}
  putblk(x*21,y*21,3,0); {staafje wordt wit}
  chk_dicht(player);     {zijn er kamers bijgekomen door player?}
end;
procedure veranderyveld(x,y,player:word); {de andere computer geeft dit..}
var
  cntr:word;
  cntr2:word;
  getem:integer;
begin
  veldy[x,y]:=1;         {staafje wordt bezet}
  putblk(x*21,y*21,3,1); {staafje wordt wit}
  chk_dicht(player);     {zijn er kamers bijgekomen door player?}
end;



procedure put_grid;
begin
 for calcy:=0 to 8 do begin
   for calcx:=0 to 14 do begin
    putblk(calcx*21,calcy*21,0,0);
   end;
 end;

 for calcy:=0 to 7 do begin
   for calcx:=0 to 15 do begin
    putblk(calcx*21,calcy*21,0,1);
   end;
 end;
end;


begin

  clrscr;
  read_pic;
  ch_res($13);  {320*200*256}

  self_id:=0;
  randomize;
  for cntr:=1 to 2 do begin
    self_id:=(self_id shl 8)+32+random(64);
  end;
  other_id:=0;
  mx2:=160;
  my2:=100;

  serialinit;

  make_pal;


  copy_boterks2scrns;

  beurt:=1;
  implayernr:=1;
  otherplayer_message:='';
  self_score:=0;
  other_score:=0;
  self_win:=0;
  other_win:=0;
  aantal_hokjes_dicht_prev:=0;
  aantal_hokjes_dicht:=0;
  put_grid;

  repeat
    serial;

    put_muisenscrn;

    if (knop=1) then begin {ik druk op een knop}
      if (beurt=1) then begin  {en ik ben aan de beurt}
        mx_inbox:=mx mod 21;
        my_inbox:=my mod 21;

        click_veld_x:=trunc(mx/21);
        click_veld_y:=trunc(my/21);

        if (mx<=318) AND (my<=171) then begin
          if (veldx[click_veld_x,click_veld_y]=0) then begin
            if (my_inbox<4) and (mx_inbox>4) then begin
              veranderxveld(click_veld_x,click_veld_y,implayernr);
              send_veldx_change(click_veld_x,click_veld_y,implayernr);
              if (aantal_hokjes_dicht=0) then begin
                beurt:=2;
                send_jijhebtdebeurt;
              end;
            end;
          end;
          if (veldy[click_veld_x,click_veld_y]=0) then begin
            if (mx_inbox<4) and (my_inbox>4) then begin
              veranderyveld(click_veld_x,click_veld_y,implayernr);
              send_veldy_change(click_veld_x,click_veld_y,implayernr);
              if (aantal_hokjes_dicht=0) then begin
                beurt:=2;
                send_jijhebtdebeurt;
              end;
            end;
          end;
        end;
      end;
    end;


{    if (implayernr=1) then begin {I'm the server}
 {     if (beurt=1) then begin {Ik ben aan de beurt}
 {       if (knop=1) then begin {Ik heb op een knop gedrukt}
 {         if (mx<300) then begin
            click_veld_x:=trunc(mx/101);
            click_veld_y:=trunc(my/72);
            Mx_Inbox:=mx Mod 101;
            My_Inbox:=my Mod 72;
            if veld[click_veld_x,click_veld_y]=0 then begin
              if (Mx_inbox>6) AND (Mx_inbox<79) AND (My_inbox<52) then begin
                beurt:=2; {ik mag niet meer...}
{                send_veld_change(click_veld_x,click_veld_y,implayernr);
                veranderveld(click_veld_x,click_veld_y,implayernr);
                send_jijhebtdebeurt;
              end;
            end;
          end;
        end;
      end;
    end;
    if (implayernr=2) then begin {I'm the client}
{      if (beurt=1) then begin {Ik heb de beurt gekregen}
{        if (knop=1) then begin {Ik heb op een knop gedrukt}
{          if (mx<300) then begin
{            click_veld_x:=trunc(mx/101);
            click_veld_y:=trunc(my/72);
            Mx_Inbox:=mx Mod 101;
            My_Inbox:=my Mod 72;
            if veld[click_veld_x,click_veld_y]=0 then begin
              if (Mx_inbox>6) AND (Mx_inbox<79) AND (My_inbox<52) then begin
                beurt:=2; {ik mag niet meer...}
{                send_veld_change(click_veld_x,click_veld_y,implayernr);
                veranderveld(click_veld_x,click_veld_y,implayernr);
                send_jijhebtdebeurt;
              end;
            end;
          end;
        end;
      end;
    end;



    {DE GEBRUIKER TYPT OP HET TOETSENBORD}


    can_xmit;
    IF KeyPressed THEN Begin
      keypress := ReadKey;

      if (ORD(keypress)>=32) then stringpacketout:=stringpacketout+keypress;
      if (keypress=CHR(8)) then begin
        backspace(stringpacketout);
      end;
      if (keypress=CHR(13)) then begin
        self_cursorx:=0;
        self_cursory:=24;
        send_string_packet(stringpacketout);
        stringpacketout:='';
      end;
    End;

  until keypress=CHR(27);

  Port[ COM1 + IER ] := 0; { Disable interrupts }
  Port[ PIC_CNTL ] := Port[ PIC_CNTL ] AND (NOT IRQ4_MASK); { Set PIC control register to disable IRQ4. }
  SetIntVec( COM_INT, save_int ); { Restore old interrupt routine. }

  ch_res($03);
end.
